#define  LM_ALL

#include "lightmat.h"

#include <math.h>

void foo(doubleVec3 ){};
void foor(doubleVec3 &  ){};
void fooc(const doubleVec3 ){};
void foocr(const doubleVec3 &  ){};
void foon(doubleN ){};
void foorn(doubleN &  ){};
void foocn(const doubleN ){};
void foocrn(const doubleN &  ){};

intN Global_TRotateLeftb ( const intN &a)
{
    int m = 4;
    intN res(4);

    res = a;
    cout << (res(R(2,4)));
    cout << "\n";
    res(1) = a(2);
    res(2) = a(3);
    res(3) = a(4);
    res.Set(R(1,3),a(R(2,4)));
    return res;
}




int main(){
    int3 w; 
    doubleVec3 p;
foo(w);
//foor(w); // warning
fooc(w);
foocr(w);
//foon(w);
//foorn(w);
//foocn(w);
//foocrn(w);
foon(p);
//foorn(p); // warning
foocn(p);
foocrn(p);

intN a(4);
intN b(4);

a(1)=1;
a(2)=2;
a(3)=3;
a(4)=4;
b.Set(R(1,3),a(R(2,4)));
assert(b(1)==2);


    light3double a3(2);
    a3=-a3;
    double ee=7.7;
    double e=abs(ee);

    double s;
    s=pow(ee,6);

    s=pow(ee,6.0);

    int y=7;

    s=pow(y,y);
    cout << "7**7=" << s;

    s=asinh(s);
    int rr=2;
    // int r=int(rr)+sign(r)+sign(ee); <- strange...
    int r=int(rr)+sign(rr)+sign(ee);
    

    // This demonstrates bug in g++ 2.6.
    // If we have such call and 
    //     double abs(const double x)
    // is not defined in transf.icc then
    // linker produces message:
    //        ld: fatal: symbol `sign__Fd' is multiply defined:
    //  (file ../obj/not_inlined.o and file /sw/gnu/lib/libg++.a(builtin.o));

    // If howerver we call sign()
    // and
    //      inline int sign(double x), inline int sign(int x)
    // are NOT defined in light_int.icc
    // then linker produces message:
    //    ld: fatal: symbol `abs__Fd' is multiply defined:
    //    (file ../obj/not_inlined.o and file /sw/gnu/lib/libg++.a(builtin.o));

    // Actually, abs__Fd and sign__Fd ARE defined. 
    // abs__Fl and sign__Fl ARE defined.
    // ans__Fi and sign__Fi ARE NO DEFINED.

    // To fix the proble I just commented out
    // double abs(const double x) and
    // inline int sign(double x)

return 0;}


