#ifndef system_h
#define system_h

#define LM_NNNN
/* Level of the library */
#include "lightmat.h"

double system_TErf ( const double &);

lm_complexN system_TFourier ( const lm_complexN &);

lm_complexN system_TFourier3 ( const lm_complexN &, const int &, const int &);

lm_complexN system_TInverseFourier ( const lm_complexN &);

lm_complexN system_TInverseFourier3 ( const lm_complexN &, const int &, const 
    int &);

intN system_TRotateLeft ( const intN &);

intN system_TRotateRight ( const intN &);

void system_TsystemInit ();

double system_TErfOne ( const double &);

double system_TErfTwo ( const double &);

#endif
